#!/bin/sh

cd /

case "$1" in
  beta)
	echo "Synchronizing BETA tree.."
	rsync -ar --progress --delete m1k2_beta@informare.org:/home/m1k2_beta/current/* .
	;;
  *)
        echo "Synchronizing STABLE tree.."
        rsync -ar --progress --delete m1k2@informare.org:/home/m1k2/current/* .
	;;
esac
	
chown -R root:root bin etc fpga lib sbin static uImage usr var system www

cp /etc/init_archive/S15flash_fpga /etc/init.d/

sync; sync; sync
echo
echo "Update finished."

