/**
 * @copyright Florian Faber, florian.faber@directout.eu
 * @version 1 (02.10.2013) 
 **/




function opt_click(id) {
    var cb = document.getElementById("pcb_"+id);
    var o = document.getElementById("pcbx_"+id);
    var x = (o && o.checked)?1:0;

    ajax_call("/cmd/opt_perm?"+id+","+(cb.checked?1:0)+","+x);
}


function init_mypermissions() {
    var t = document.getElementById('table_perms');

    while (t.rows.length>3)
				t.deleteRow(3);
    
    var o = document.getElementById('my_permissions');

    if (top.frames[0].myperms.length==0) {
				o.innerHTML = "<i>Not logged in</i>";
				return;
    }
    o.innerHTML = top.frames[0].myperms["permissionname"];
    
    var myperms = top.frames[0].myperms;

    if (top.frames[0].myperms["optional_perms"].length==0) {
				// show note
				var row = t.insertRow(-1);
				var td = row.insertCell(0);
				td = row.insertCell(1);
				td.innerHTML = "<i>You have no optional permissions.</i>";

    } else {
				for (var i=0; i<top.frames[0].myperms["optional_perms"].length; i++) {
						var row = t.insertRow(-1);
						var td = row.insertCell(0);
						td.style.textAlign = 'right';
						td.style.verticalAlign = 'top';
						td.innerHTML = "<input type='checkbox' id='pcb_"+top.frames[0].myperms["optional_perms"][i]["id"]+"'"+(top.frames[0].myperms["optional_perms"][i]["active"]==1?" checked":"")+(((top.frames[0].myperms["optional_perms"][i]["exclusively"].length>0) && (top.frames[0].myperms["optional_perms"][i]["xactive"]==0))?" disabled":"")+" onchange='opt_click("+top.frames[0].myperms["optional_perms"][i]["id"]+");'>";
						td = row.insertCell(1);
						td.innerHTML = top.frames[0].myperms["optional_perms"][i]["name"];
						td.style.verticalAlign = 'top';
						if (((top.frames[0].myperms["optional_perms"][i]["active"]==1) && (top.frames[0].myperms.optional_perms[i].in_use.length==1)) || (top.frames[0].myperms.optional_perms[i].in_use.length==0)) {
								td = row.insertCell(2);
								td.innerHTML = "<input type='checkbox' id='pcbx_"+top.frames[0].myperms["optional_perms"][i]["id"]+"'"+(top.frames[0].myperms["optional_perms"][i]["xactive"]==1?" checked":"")+(top.frames[0].myperms["optional_perms"][i]["active"]==0?" disabled":"")+" onchange='opt_click("+top.frames[0].myperms["optional_perms"][i]["id"]+");'>";
								td = row.insertCell(3);
								td.innerHTML = "use exclusively";
						} else {
								td = row.insertCell(2);
								td = row.insertCell(3);
								if (top.frames[0].myperms["optional_perms"][i]["exclusively"]!="") {
										td.innerHTML = "<b>Currently in exclusive use by:</b>";
								} else {
										td.innerHTML = "<b>Currently in use by:</b>";
								}
								top.frames[0].myperms.optional_perms[i].in_use.sort();
								for (var j=0; j<top.frames[0].myperms.optional_perms[i].in_use.length; j++) {
										td.innerHTML += "<br>" + top.frames[0].myperms.optional_perms[i].in_use[j];
								}	   
						} 
				}
    }
}
