/**
 * M1k2 status update
 * @copyright Florian Faber, florian.faber@directout.eu
 * @version 1 (09.11.2011) 
 **/



function check_pass1() {
  var p1 = document.getElementById('new_pass1');
  var info1 = document.getElementById('pass_info1');
  if (p1.value.length<5) {
    p1.style.backgroundColor = 'red';
    info1.innerHTML = "Too short (5 chars minimum)";
    document.getElementById("set_password").disabled = true;
    return false;
  } else {
    p1.style.backgroundColor = 'green';
    info1.innerHTML = "OK.";
  }

  return true;
}

function check_pass2() {
  var p1 = document.getElementById('new_pass1');
  var p2 = document.getElementById('new_pass2');
  var info2 = document.getElementById('pass_info2');

  if (p1.value!=p2.value) {
    p2.style.backgroundColor = 'red';
    info2.innerHTML = "Does not match!"
    document.getElementById("set_password").disabled = true;
    return false;
  } else {
    p2.style.backgroundColor = 'green';
    info2.innerHTML = "OK."
    document.getElementById("set_password").disabled = false;
  }

  return true;
}


function pass_response(res) {
  document.getElementById("set_password").disabled = false;
  lines = res.split('\n');
  if (lines[1])
    document.getElementById(lines[1]).focus();
  if (lines[0]!='') {
    document.body.style.cursor = 'default';
    alert(lines[0]); 
  }
}

function set_password() {
  if (check_pass1() && check_pass2()) {
    document.body.style.cursor = 'wait';
    document.getElementById("set_password").disabled = true;
    var str = document.getElementById("old_pass").value+"\n"+document.getElementById("new_pass1").value+"\n"+document.getElementById("new_pass2").value;
    post_call("/cmd/my_pass", str, pass_response);
 
  }
}
