/*
 * @copyright D.O.TEC
 * @author Florian Faber, florian.faber@directout.eu
 * @version 3 (11.08.2016)
 * @version 2 (28.05.2012)
 **/

var editable = false;


function xp_enable(id, type) {
	var enable = true;
	for (var i=0; i<64; i++) {
		if (document.getElementById("xp"+type+"_"+id+"_"+i).checked)
			enable = false;
	}					  
	for (var i=0; i<64; i++) {
		document.getElementById("xp"+type+"_"+id+"_"+i).checked = enable;
	}
}


function xp_eight(id, type, group) {
	var enable = true;
	for (var i=0; i<8; i++) {
		if (document.getElementById("xp"+type+"_"+id+"_"+(i+group*8)).checked)
			enable = false;
	}					  
	for (var i=0; i<8; i++) {
		document.getElementById("xp"+type+"_"+id+"_"+(i+group*8)).checked = enable;
	}
}


function create_xps() {
	var t = document.getElementById('xps');

	while (t.rows.length>1)
		t.deleteRow(1);
 
	for (var port=0; port<16; port++) {
		var r = t.insertRow(-1);
		var c = r.insertCell(0);
		c.innerHTML = "Port "+(port+1);
		c = r.insertCell(1);
		c.style.textAlign = 'center';
		if (editable)
			c.innerHTML = "<div class='btn_goe' onclick='xp_enable("+port+", \"i\");' title=\"group-o'-sixtyfour\">1..64</div>";
		c = r.insertCell(2);
		c.style.textAlign = 'center';
		if (editable)
			c.innerHTML = "<div class='btn_goe' onclick='xp_enable("+port+", \"o\");' title=\"group-o'-sixtyfour\">1..64</div>";
		r = t.insertRow(-1);
		r.insertCell(0);
		c = r.insertCell(1);
		c.innerHTML = "<table id='xp_ichannels_"+port+"'></table>";
		var t2 = document.getElementById('xp_ichannels_'+port);
		c = r.insertCell(2);
		c.innerHTML = "<table id='xp_ochannels_"+port+"'></table>";
		var t3 = document.getElementById('xp_ochannels_'+port);
		for (var g=0; g<8; g++) {
			r = t2.insertRow(-1);
			c = r.insertCell(0);
			c.style.textAlign = 'right';
			c.innerHTML = (g*8+1)+".."+((g+1)*8);
			c = r.insertCell(1);
			str = "";
			for (var ch=0; ch<8; ch++)
				str += "<input type='checkbox' id='xpi_"+port+"_"+(g*8+ch)+"'>";
			c.innerHTML = str;
			c = r.insertCell(2);
			if (editable)
				c.innerHTML = "<div class='btn_goe' onclick='xp_eight("+port+", \"i\", "+g+");' title=\"group-o'-eight\"></div>";

			r = t3.insertRow(-1);
			c = r.insertCell(0);
			c.style.textAlign = 'right';
			c.innerHTML = (g*8+1)+".."+((g+1)*8);
			c = r.insertCell(1);
			str = "";
			for (var ch=0; ch<8; ch++)
				str += "<input type='checkbox' id='xpo_"+port+"_"+(g*8+ch)+"'>";
			c.innerHTML = str;
			c = r.insertCell(2);
			if (editable)
				c.innerHTML = "<div class='btn_goe' onclick='xp_eight("+port+", \"o\", "+g+");' title=\"group-o'-eight\"></div>";
		}
	}
}


function bintohex(str) {
	var res = "";
	var rem = str.length%8;
	for (var i=0; i<rem; i++)
		str += "0";
 
	for (var i=0; i<str.length; i+=4) {
		res += parseInt(str.substring(i, i+4), 2).toString(16);
	}
	return res;
}


function cb_store_response(res) {
	if (res=="OK")
		parent.frames[1].location="/en/config/user.html";
}


function submit() {
	var str = "";

	if ((permissionid>0) && !clone)
		str = permissionid+"\n";

	str += document.getElementById("name").value+"\n";
	
	var binstr = "";
	for (var p=0; p<16; p++) {
	  for (var ch=0; ch<64; ch++) {
	    binstr += (document.getElementById("xpi_"+p+"_"+ch).checked)?"1":"0";
	  }
	}
	for (var p=0; p<16; p++) {
	  for (var ch=0; ch<64; ch++) {
	    binstr += (document.getElementById("xpo_"+p+"_"+ch).checked)?"1":"0";
	  }
	}
	binstr += (document.getElementById("lock_policy_1").checked)?"1":"0";
	binstr += (document.getElementById("gain_policy_1").checked)?"1":"0";
	binstr += (document.getElementById("label_policy_1").checked)?"1":"0";
	for (var i=0; i<18; i++) 
		binstr += (document.getElementById("clock_"+i).checked)?"1":"0";
	for (var i=0; i<16; i++)
		binstr += (document.getElementById("port_"+i+"_mf").checked)?"1":"0";
	for (var i=0; i<16; i++)
		binstr += (document.getElementById("port_"+i+"_ir").checked)?"1":"0";
	for (var i=0; i<16; i++)
		binstr += (document.getElementById("port_"+i+"_or").checked)?"1":"0";
	for (var i=0; i<18; i++)
		binstr += (document.getElementById("ser_"+i+"_mi").checked)?"1":"0";
	for (var i=0; i<18; i++) 
		binstr += (document.getElementById("ser_"+i+"_mo").checked)?"1":"0";
	for (var i=0; i<20; i++) 
		binstr += (document.getElementById("ser_"+i+"_si").checked)?"1":"0";
	for (var i=0; i<20; i++) 
		binstr += (document.getElementById("ser_"+i+"_so").checked)?"1":"0";
	for (var i=0; i<4; i++) 
		binstr += (document.getElementById("gpo_"+i).checked)?"1":"0";
	for (var i=0; i<24; i++) {
	  var o = document.getElementById("cfg_"+i);
	  if (o) {
	    binstr += (o.checked)?"1":"0";
	  } else {
			binstr += "0";
	  }
	}
		binstr += "1";
		
	str += bintohex(binstr);
	
	if ((permissionid>0) && !clone)
		post_call("/data/permission_change", str, cb_store_response);
	else
		post_call("/data/permission_new", str, cb_store_response);
}


function cb_fill_in(res) {
	res = res.split('\n');
	document.getElementById('name').value = (clone?"Copy of ":"")+res[0];
	if (!editable)
		document.getElementById('name').disabled = true;

	for (var p=0; p<16; p++) {
		for (var ch=0; ch<64; ch++) {
			var o = document.getElementById("xpi_"+p+"_"+ch);
			o.checked = (res[1][p*64+ch]=="1");
			if (!editable)
				o.disabled = true;
		}
	}
	for (var p=0; p<16; p++) {
		for (var ch=0; ch<64; ch++) {
			var o = document.getElementById("xpo_"+p+"_"+ch);
			o.checked = (res[2][p*64+ch]=="1");
			if (!editable)
				o.disabled = true;
		}
	}

	document.getElementById("lock_policy_"+res[3][0]).checked = true;
	document.getElementById("gain_policy_"+res[3][1]).checked = true;
	document.getElementById("label_policy_"+res[3][2]).checked = true;

	if (!editable) {
		document.getElementById("label_policy_0").disabled = true;
		document.getElementById("label_policy_1").disabled = true;
		document.getElementById("lock_policy_0").disabled = true;
		document.getElementById("lock_policy_1").disabled = true;
		document.getElementById("gain_policy_0").disabled = true;
		document.getElementById("gain_policy_1").disabled = true;
	}

	var pos = 3;
	for (var i=0; i<18; i++)
		document.getElementById("clock_"+i).checked = (res[3][pos++]=="1");
	for (var i=0; i<16; i++)
		document.getElementById("port_"+i+"_mf").checked = (res[3][pos++]=="1");
	for (var i=0; i<16; i++)
		document.getElementById("port_"+i+"_ir").checked = (res[3][pos++]=="1");
	for (var i=0; i<16; i++)
		document.getElementById("port_"+i+"_or").checked = (res[3][pos++]=="1");
	for (var i=0; i<18; i++)
		document.getElementById("ser_"+i+"_mi").checked = (res[3][pos++]=="1");
	for (var i=0; i<18; i++) 
		document.getElementById("ser_"+i+"_mo").checked = (res[3][pos++]=="1");
	for (var i=0; i<20; i++) 
		document.getElementById("ser_"+i+"_si").checked = (res[3][pos++]=="1");
	for (var i=0; i<20; i++) 
		document.getElementById("ser_"+i+"_so").checked = (res[3][pos++]=="1");
	for (var i=0; i<4; i++) 
		document.getElementById("gpo_"+i).checked = (res[3][pos++]=="1");
	for (var i=0; i<24; i++) {
	  var o = document.getElementById("cfg_"+i);
	  if (o)
	    o.checked = (res[3][pos]=="1");
	  pos++;
	}

	if (!editable) {
		for (var i=0; i<18; i++)
			document.getElementById("clock_"+i).disabled = true;
		for (var i=0; i<16; i++)
			document.getElementById("port_"+i+"_mf").disabled = true;
		for (var i=0; i<16; i++)
			document.getElementById("port_"+i+"_ir").disabled = true;
		for (var i=0; i<16; i++)
			document.getElementById("port_"+i+"_or").disabled = true;
		for (var i=0; i<18; i++)
			document.getElementById("ser_"+i+"_mi").disabled = true;
		for (var i=0; i<18; i++) 
			document.getElementById("ser_"+i+"_mo").disabled = true;
		for (var i=0; i<20; i++) 
			document.getElementById("ser_"+i+"_si").disabled = true;
		for (var i=0; i<20; i++) 
			document.getElementById("ser_"+i+"_so").disabled = true;
		for (var i=0; i<4; i++) 
			document.getElementById("gpo_"+i).disabled = true;
		for (var i=0; i<24; i++) 
			document.getElementById("cfg_"+i).disabled = true;
	}
}


function cb_fill_users(response) {
	var t = document.getElementById('table_users');
	
	while (t.rows.length>1)
		t.deleteRow(1);

	var rows = response.split('\n');
	
	if (rows.length>1) {
		document.getElementById('perm_usage').style.display = 'block';

		for (var i=0; i<rows.length; i++) {
			var line = rows[i].split(';');
			if (line[1]) {
				var row = t.insertRow(-1);
				if (i%2==1)
					row.className = "odd";
				
				var td = row.insertCell(0);
				td.innerHTML = line[2]+" ("+line[1]+")";
				
				td = row.insertCell(1);
				td.style.fontSize = "10px";
				td.style.textAlign = 'center';
				if (line[3]==0)
					td.innerHTML = 'X';
				else
					td.innerHTML = '';
				
				td = row.insertCell(2);
				td.style.fontSize = "10px";
				td.style.textAlign = 'center';
				if (line[4]>0)
					td.innerHTML = line[4];
				else
					td.innerHTML = '-';
				
				td = row.insertCell(3);
				td.style.fontSize = "10px";
				if (line[4]>0)
					td.innerHTML = format_timestamp(line[5]);
				else
					td.innerHTML = '-';
				
				td = row.insertCell(4);
				td.style.fontSize = "10px";
				td.style.textAlign = 'center';
				if (line[6]==0)
					td.innerHTML = 'no';
				else
					td.innerHTML = 'yes';
			}
		}
	}
}


function init_port(id) {
	if (clone) {
		document.getElementById("title_h1").innerHTML = "Clone Permission Class";
		document.getElementById("commit_0").innerHTML = "Create Permission Class Clone";
		document.getElementById("perm_usage").style.display = "none";
		for (var i=1; i<7; i++) 
			document.getElementById("commit_"+i).style.display = "none";
		
		editable = true;

		ajax_call('/data/permission?'+id, cb_fill_in);
	       
	} else if ((typeof(id)=="string") && (id<4)) {
		document.getElementById("title_h1").innerHTML = "View Permission Class";
		for (var i=0; i<7; i++) 
			document.getElementById("commit_"+i).style.display = "none";

		ajax_call('/data/permission?'+id, cb_fill_in);
		ajax_call('/data/permission_users?'+id, cb_fill_users);
		
	} else {
		document.getElementById("title_h1").innerHTML = "Edit Permission Class";
		document.getElementById("commit_0").innerHTML = "Store Permission Class";
		document.getElementById("perm_usage").style.display = "none";
		for (var i=1; i<7; i++) 
			document.getElementById("commit_"+i).style.display = "none";
		
		editable = true;
		
		if (typeof(id)=="string") {
			ajax_call('/data/permission?'+id, cb_fill_in);
			ajax_call('/data/permission_users?'+id, cb_fill_users);
		}

		document.getElementById('commit_1').focus();
	}

	create_xps();
}


