var rt_socket, rt_connected=0, rt_onconnect=false, rt_ondisconnect=false, rt_reconnect;

function rt_disconnected() {
  if (rt_reconnect) {
    if (rt_socket.readyState!=rt_socket.CLOSED)
      rt_socket.close();
    
    rt_connected = 0;
    
    window.setTimeout("rt_connect()", 1000);
    
    if (rt_ondisconnect)
      rt_ondisconnect();
  }
}


function rt_callback(event) {
  if (rt_connected==0) {
    rt_connected = 1;

    if (rt_onconnect)
      rt_onconnect();
  }
  
  var ar = new Uint8Array(event.data);
  signals(ar);
}


function rt_connect() {
  rt_socket = new WebSocket('ws://'+window.location.host+'/ws/realtime');
  rt_socket.binaryType = "arraybuffer";
  rt_socket.onmessage = rt_callback;
  rt_socket.onclose = rt_disconnected; 
  rt_reconnect = true;
}

function rt_disconnect() {
  if (!rt_socket)
    return;

  rt_reconnect = false;

  if (rt_socket.readyState!=rt_socket.CLOSED)
    rt_socket.close();

  rt_connected = 0;
}

function rt_init(onconnect, ondisconnect) {
  if ("WebSocket" in window) {
    rt_connect();
    rt_onconnect = onconnect;
    rt_ondisconnect = ondisconnect;
  }
}
