
var selcnt=0;

function ssl_update_selcnt() {
	document.getElementById('sel_cnt').innerHTML = ((selcnt==0)?"No":selcnt)+" snapshot"+((selcnt==1)?"":"s")+" selected.";
	document.getElementById('ssl_del').disabled = (selcnt==0);
}


function ssl_ss_cb_selected(e) {
  var srcElement;

  if (e.srcElement) {
    srcElement = e.srcElement;
  } else if (e.originalTarget) {
    srcElement = e.originalTarget;
  }

	if (srcElement.checked) {
		selcnt++;
	} else {
		selcnt--;
		srcElement.parentNode.parentNode.children[0].children[0].checked = false;
	}
	ssl_update_selcnt();
}


function ssl_pr_cb_selected(e) {
  var srcElement;

  if (e.srcElement) {
    srcElement = e.srcElement;
  } else if (e.originalTarget) {
    srcElement = e.originalTarget;
  }

	var pr = srcElement.parentNode.parentNode;
	for (var i=1; i<pr.children.length; i++) {
		var ss = pr.children[i];
		if (!ss.children[3].checked && srcElement.checked) {
			selcnt++;
		} else if (ss.children[3].checked && !srcElement.checked) {
			selcnt--;
		}
		ss.children[3].checked = srcElement.checked;
	}

	ssl_update_selcnt();
}


function ssl_ss_download(e) {
  var srcElement;

  if (e.srcElement) {
    srcElement = e.srcElement;
  } else if (e.originalTarget) {
    srcElement = e.originalTarget;
  }

	window.location='/data/download_snapshot?'+srcElement.ss_id;
}


function ssl_get_project(name) {
	var c = document.getElementById('snapshot_list');
	for (var i=0; i<c.children.length; i++) {
		if (c.children[i].name==name)
			return c.children[i];
	}
	return false;
}


function ssl_add_project(name, bg, fg) {
	var d = document.createElement('div');
	d.className = 'ssl_project';
	d.name = name;
	d.style.borderLeft = '25px solid #'+bg;
	var c = document.createElement('div');
	c.className = 'ssl_project_name';
	c.style.backgroundColor = '#'+bg;
	c.style.color = '#'+fg;
	c.innerHTML = name;
	d.appendChild(c);
	var o = document.createElement('input');
	o.type = 'checkbox';
	o.title = 'select/deselect project';
	o.className = 'ssl_project_cb';
	o.onchange = ssl_pr_cb_selected;
	c.appendChild(o);

	document.getElementById('snapshot_list').appendChild(d);
	return d;
}


function ssl_add_snapshot(project, id, ts, da, bg, fg, name, co) {
	var d = document.createElement('div');
	d.style.backgroundColor = '#'+bg;
	d.style.color = '#'+fg;
	d.className = 'ssl_snapshot';
	d.name = name;
	d.ts = ts;
	d.co = co;
	d.ss_id = id;
	d.id = "ss_"+id;
	var o = document.createElement('div');
	o.className = 'ssl_snapshot_name';
	o.innerHTML = name;
	d.appendChild(o);
	o = document.createElement('div');
	o.className = 'ssl_snapshot_timestamp';
	o.innerHTML = da;
	d.appendChild(o);
	o = document.createElement('div');
	o.className = 'ssl_snapshot_download';
	o.ss_id = id;
	o.title = 'Download snapshot..';
	o.onclick = ssl_ss_download;
	d.appendChild(o);
	o = document.createElement('input');
	o.type = 'checkbox';
	o.title = 'select/deselect snapshot';
	o.className = 'ssl_snapshot_cb';
	o.onchange = ssl_ss_cb_selected;
	o.id = 'cb_'+id;
	d.appendChild(o);
	if (co!="") {
		o = document.createElement('div');
		o.className = 'ssl_snapshot_comment';
		o.innerHTML = co;
		d.appendChild(o);
	}

	project.appendChild(d);
}


function cb_projects(res) {
	var projs = res.split('\n');
	for (var i=0; i<projs.length; i++) {
		var pr = projs[i].split(';');
		var c = ssl_get_project(pr[0]);
		if (!c)
			c = ssl_add_project(pr[2], pr[1], pr[0]);
	}
	ajax_call("/data/snapshots", cb_snapshots);
}


function cb_snapshots(res) {
	var snaps = res.split('\n');
	
	for (var i=0; i<snaps.length; i++) {
		var ss = snaps[i].split(';');
		var c = ssl_get_project(ss[3]);
		if (c)
			ssl_add_snapshot(c, ss[0], ss[1], ss[2], ss[5], ss[4], ss[6], urldecode(ss[7]));
	}
	
}



function ssl_delete() {
	var sl = document.getElementById('snapshot_list');
	for (var i=0; i<sl.children.length; i++) {
		for (var j=1; j<sl.children[i].children.length; j++) {
			if (sl.children[i].children[j].children[3].checked) {
				send_cmd("snapshot_delete?"+sl.children[i].children[j].ss_id);
				sl.children[i].removeChild(sl.children[i].children[j]);
				j--;
			}
		}
		if (sl.children[i].children.length==1) {
			sl.removeChild(sl.children[i]);
			i--;
		}
	}
}


function ess_usage(id, usage) {
	var o = document.getElementById('snapshot_free');
	o.innerHTML = "User partition usage: "+usage+"% (=space for additional ~"+((100-usage)*80)+" snapshots)";
}


function snapshotlist_init() {
	ess_usage(1, parent.frames[0].status_usage[1]);
	ajax_call("/data/projects", cb_projects);
	ssl_update_selcnt();
}



